package core

import (
	"gitlab.com/oiacow/goheroes/backend/core/codec"
)

// ClientEvent is the generic struct for events
// by this Client
type ClientEvent struct {
	Name string
	Data interface{}
}

type EClientCmd struct {
	Client *Client
	// If TLS (theater then we ignore payloadID - it is always 0x0)
	Cmd *codec.Cmd
}

func (c *Client) FireClientClose(event ClientEvent) SocketEvent {
	return SocketEvent{
		Name: "client.close",
		Data: EClientCmd{Client: c},
	}
}

func (c *Client) FireClose() ClientEvent {
	return ClientEvent{Name: "close", Data: c}
}

func (c *Client) FireClientCmd(event ClientEvent) SocketEvent {
	return SocketEvent{
		Name: "client." + event.Name,
		Data: EClientCmd{
			Client: c,
			Cmd:    event.Data.(*codec.Cmd),
		},
	}
}
