package acct

import (
	"gitlab.com/oiacow/goheroes/backend/core"
	"gitlab.com/oiacow/goheroes/backend/core/codec"
	"gitlab.com/oiacow/goheroes/backend/storage/database"
)

const (
	acctGetTelemetryToken = "TeleToken"
	acctNuGetAccount      = "NuGetAccount"
	acctNuGetPersonas     = "NuGetPersonas"
	acctNuLogin           = "NuLogin"
	acctNuLoginPersona    = "NuLoginPersona"
	acctNuLookupUserInfo  = "NuLookupUserInfo"
)

const (
	clientTypeServer = "server"
)

// Account probably stands for "Account"
type Account struct {
	DB database.Adapter
}

func (acct *Account) answer(client *core.Client, pnum uint32, payload interface{}) {
	client.WriteEncode(&codec.Answer{
		Type:         codec.FeslAccount,
		PacketNumber: pnum,
		Payload:      payload,
	})
}
