package fsys

import (
	"gitlab.com/oiacow/goheroes/backend/core"
)

type ansGetPingSites struct {
	// TXN stands for Taxon, sub-query name of the cmd.
	TXN       string     `fesl:"TXN"`
	MinPings  int        `fesl:"minPingSitesToPing"`
	PingSites []pingSite `fesl:"pingSites"`
}

type pingSite struct {
	Addr string `fesl:"addr"`
	Name string `fesl:"name"`
	Type int    `fesl:"type"`
}

var pingSites = []pingSite{
	{"167.114.115.226", core.RegionAsia, 0},
	{"167.114.115.226", core.RegionEurope, 0},
	{"167.114.115.226", core.RegionEastCoast, 0},
	{"167.114.115.226", core.RegionWestCoast, 0},
}

// GetPingSites handles fsys.GetPingSites cmd.
func (fsys *ConnectSystem) GetPingSites(event core.EClientCmd) {
	fsys.answer(
		event.Client,
		event.Cmd.PayloadID,
		ansGetPingSites{
			TXN:       fsysGetPingSites,
			MinPings:  0,
			PingSites: pingSites,
		},
	)
}
