package dbtest

import (
	"github.com/gocraft/dbr"
	"gitlab.com/oiacow/goheroes/backend/model"
)

type QueriesAdapter struct {
	Server                model.Server
	ErrSelectServer       error
	ErrSelectServerByName error
	ErrSelectServerLogin  error

	Player                 model.Player
	ErrSelectPlayerByToken error
	ErrSelectPlayerByID    error

	Heroes                    []model.Hero
	ErrSelectHeroesByPlayerID error
	Hero                      model.Hero
	ErrSelectHeroByName       error
	HeroStats                 model.HeroStats
	ErrGetHeroStats           error
	ErrUpdateHeroStats        error
}

func (a *QueriesAdapter) GetServerByID(sess *dbr.Session, serverID int) (model.Server, error) {
	return a.Server, a.ErrSelectServer
}
func (a *QueriesAdapter) GetServerByName(sess *dbr.Session, soldierName string) (model.Server, error) {
	return a.Server, a.ErrSelectServerByName
}
func (a *QueriesAdapter) GetServerLogin(sess *dbr.Session, accountName string) (model.Server, error) {
	return a.Server, a.ErrSelectServerLogin
}

func (a *QueriesAdapter) GetPlayerByToken(sess *dbr.Session, token string) (model.Player, error) {
	return a.Player, a.ErrSelectPlayerByToken
}
func (a *QueriesAdapter) GetPlayerByID(sess *dbr.Session, heroID int) (model.Player, error) {
	return a.Player, a.ErrSelectPlayerByID
}

func (a *QueriesAdapter) GetHeroesByPID(sess *dbr.Session, heroID int) ([]model.Hero, error) {
	return a.Heroes, a.ErrSelectHeroesByPlayerID
}
func (a *QueriesAdapter) GetHeroByName(sess *dbr.Session, heroName string) (model.Hero, error) {
	return a.Hero, a.ErrSelectHeroByName
}
func (a *QueriesAdapter) GetHeroStats(sess *dbr.Session, heroID int) (model.HeroStats, error) {
	return a.HeroStats, a.ErrGetHeroStats
}
func (a *QueriesAdapter) UpdateStats(tx *dbr.Tx, heroID int, pr *model.HeroStats) error {
	return a.ErrUpdateHeroStats
}
