package theater

import (
	"time"

	"gitlab.com/oiacow/goheroes/backend/core"
	"gitlab.com/oiacow/goheroes/backend/core/codec"
)

type reqCONN struct {
	// TID=1
	TID int `fesl:"TID"`

	// LOCALE=en_US
	Locale string `fesl:"LOCALE"`
	// PLAT=PC"
	Platform string `fesl:"PLAT"`
	// PROD=bfwest-pc
	Prod string `fesl:"PROD"`
	// PROT=2
	Protocol int `fesl:"PROT"`
	// SDKVERSION=5.0.0.0.0
	SdkVersion string `fesl:"SDKVERSION"`
	// VERS="1.42.217478.0 "
	Version string `fesl:"VERS"`
}

type ansCONN struct {
	TID         string `fesl:"TID"`
	ConnectedAt int64  `fesl:"TIME"`
	ConnTTL     int    `fesl:"activityTimeoutSecs"`
	Protocol    string `fesl:"PROT"`
}

func (tm *Theater) Connect(event core.EClientCmd) {
	event.Client.WriteEncode(&codec.Answer{
		Type: codec.ThtrConnect,
		Payload: ansCONN{
			TID:         event.Cmd.Msg["TID"],
			ConnectedAt: time.Now().UTC().Unix(),
			ConnTTL:     int((60 * time.Second).Seconds()),
			Protocol:    event.Cmd.Msg["PROT"],
		},
	})
}
