package theater

import (
	"gitlab.com/oiacow/goheroes/backend/core"
	"github.com/sirupsen/logrus"

	"gitlab.com/oiacow/goheroes/backend/core/codec"
)

type reqECNL struct {
	// TID=8
	TID int `fesl:"TID"`
	// GID=3
	GameID int `fesl:"GID"`
	// LID=1
	LobbyID int `fesl:"LID"`
}

type ansECNL struct {
	TID     string `fesl:"TID"`
	GameID  string `fesl:"GID"`
	LobbyID string `fesl:"LID"`
}

func (tm *Theater) EnterConnLost(event core.EClientCmd) {
	logrus.Println("===ECNL SENT===")

	event.Client.WriteEncode(&codec.Answer{
		Type: codec.ThtrEnterConnectionLost,
		Payload: ansECNL{
			event.Cmd.Msg["TID"],
			event.Cmd.Msg["GID"],
			event.Cmd.Msg["LID"],
		},
	})
}
