package theater

import (
	"gitlab.com/oiacow/goheroes/backend/core"
	"github.com/sirupsen/logrus"

	"gitlab.com/oiacow/goheroes/backend/core/codec"
)

type reqEGEG struct {
	reqEGAM
}

type ansEGEG struct {
	TID            string `fesl:"TID"`
	Platform       string `fesl:"PL"`
	Ticket         int `fesl:"TICKET"`
	PlayerID       int    `fesl:"PID"`
	IP             string `fesl:"I"`
	Port           string `fesl:"P"`
	HostUserID     int `fesl:"HUID"`
	EncryptionKey  string `fesl:"EKEY"`
	NoEcryptionKey string `fesl:"NOENCYRPTIONKEY,omitempty"`
	IntIP          string `fesl:"INT-IP"`
	IntPort        string `fesl:"INT-PORT"`
	Secret         string `fesl:"SECRET,omitempty"`
	NoSecret       string `fesl:"NOSECRET,omitempty"`
	Ugid           string `fesl:"UGID,omitempty"`
	NoGUID         string `fesl:"NOGUID,omitempty"`
	LobbyID        int    `fesl:"LID"`
	GameID         int    `fesl:"GID"`
}

// EGEG is sent Client to receive last confirmation before joining game
func (tm *Theater) EGEG(event *core.EClientCmd, gameServer *core.Client, gr GameRequest) {
	gsData := gameServer.ServerData
	logrus.Println("BEGIN EGEG========")

	event.Client.WriteEncode(&codec.Answer{
		Type: codec.ThtrEnterGameEntitleGame,
		Payload: ansEGEG{
			TID:           event.Cmd.Msg["TID"],
			Platform:      "pc",
			Ticket:        gr.Ticket,
			PlayerID:      gr.PlayerID,
			IP:            gsData.Get("IP"),
			Port:          gsData.Get("PORT"),
			//HostUserID:  1,
			HostUserID:    gameServer.PlayerData.ServerID,
			EncryptionKey: "O65zZ2D2A58mNrZw1hmuJw%3d%3d",
			IntIP:         gsData.Get("INT-IP"),
			IntPort:       gsData.Get("INT-PORT"),
			Secret:        "MargeSimpson",
			Ugid:          gsData.Get("UGID"),
			LobbyID:       1,
			GameID:        gr.GameID,
		},
	})
	logrus.Println("========END EGEG")

}
