package theater

import (
	"github.com/sirupsen/logrus"
	"gitlab.com/oiacow/goheroes/backend/core"
	"gitlab.com/oiacow/goheroes/backend/core/codec"
)

type reqEGRQ struct {
	reqEGAM
}

type ansEGRQ struct {
	TID     string `fesl:"TID"`
	Name    string `fesl:"NAME"`
	UserID  int    `fesl:"UID"`
	PID     int    `fesl:"PID"`
	Ticket  int    `fesl:"TICKET"`
	IP      string `fesl:"IP"`
	Port    string `fesl:"PORT"`
	IntIP   string `fesl:"INT-IP"`
	IntPort string `fesl:"INT-PORT"`
	Ptype        string `fesl:"PTYPE"`
	RUser        string `fesl:"R-USER"`
	RUid         int    `fesl:"R-UID"`
	RUAccid      int    `fesl:"R-U-accid"`
	RUElo        string `fesl:"R-U-elo"`
	RUTeam       string `fesl:"R-U-team"`
	RUKit        string `fesl:"R-U-kit"`
	RULvl        string `fesl:"R-U-lvl"`
	RUDataCenter string `fesl:"R-U-dataCenter"`
	RUExternalIP string `fesl:"R-U-externalIp"`
	RUInternalIP string `fesl:"R-U-internalIp"`
	RUCategory   string `fesl:"R-U-category"`
	RIntIP       string `fesl:"R-INT-IP"`
	RIntPort     string `fesl:"R-INT-PORT"`
	Xuid         string `fesl:"XUID"`
	RXuid        string `fesl:"R-XUID"`
	LobbyID      string `fesl:"LID"`
	GameID       int    `fesl:"GID"`
}

//Player asks to join the server
func (tm *Theater) EnterGameRequest(event *core.EClientCmd, gameServer *core.Client, gr GameRequest) {
	logrus.Println("BEGIN EGRQ===========")
	process := event.Cmd.Msg
	gameServer.WriteEncode(&codec.Answer{ //maybe client write?
		Type: codec.ThtrEnterGameRequest,
		Payload: ansEGRQ{
			TID:          "0",
			Name:         gr.HeroName,
			UserID:       gr.HeroID,
			PID:     gr.PlayerID, //correct
			Ticket:       gr.Ticket,
			IP:           gr.extIP,
			Port:         gr.port,
			IntIP:        process["R-INT-IP"],
			IntPort:      process["R-INT-PORT"],
			Ptype:        "P",
			RUser:        gr.HeroName,
			RUid:         gr.HeroID, //todo this probably gets wrong in UpdateStats ?
			RUAccid:      gr.HeroID, //was playerID 
			RUElo:        gr.Stats["elo"],
			RUTeam:       gr.Stats["c_team"],
			RUKit:        gr.Stats["c_kit"],
			RULvl:        gr.Stats["level"],
			RUDataCenter: process["iad"],
			RUExternalIP: gr.extIP,
			RUInternalIP: process["R-INT-IP"],
			RUCategory:   process["R-U-category"],
			RIntIP:       process["R-INT-IP"],
			RIntPort:     process["R-INT-PORT"],
			Xuid:         "24",
			RXuid:        "24",
			LobbyID:      "1",
			GameID:       gr.GameID,
		},
	})
	logrus.Println("=====EGRQ END")
}
