package theater

import (
	"gitlab.com/oiacow/goheroes/backend/core"
	"gitlab.com/oiacow/goheroes/backend/core/codec"
)

type reqPLVT struct {
	// TID=16
	TID int `fesl:"TID"`

	// LID=1
	LobbyID int `fesl:"LID"`
	// GID=12
	GameID int `fesl:"GID"`
	// PID=3
	PlayerID int `fesl:"PID"`
}

type ansKICK struct {
	PlayerID string `fesl:"PID"`
	LobbyID  string `fesl:"LID"`
	GameID   string `fesl:"GID"`
}

type ansPLVT struct {
	TID string `fesl:"TID"`
}

func (tm *Theater) PlayerExited(event core.EClientCmd) {
	// pid := event.Cmd.Msg["PID"]
	// if j, err := json.Marshal(msgTeamGid{event.Cmd.Msg["GID"], stats["c_team"]}); err == nil {
	// 	tm.pub.Publish(queue.TopicTeamLeft, j)
	// }

	event.Client.WriteEncode(&codec.Answer{
		Type: thtrKICK,
		Payload: ansKICK{
			event.Cmd.Msg["PID"],
			event.Cmd.Msg["LID"],
			event.Cmd.Msg["GID"],
		},
	})

	event.Client.WriteEncode(&codec.Answer{
		Type:    thtrPLVT,
		Payload: ansPLVT{event.Cmd.Msg["TID"]},
	})
}
